/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package clientwizard;

import TomcatWS.TomcatWS;
import TomcatWS.TomcatWS_Service;
import com.sun.org.apache.xerces.internal.impl.dv.util.Base64;
import java.io.ByteArrayOutputStream;
import java.util.zip.GZIPOutputStream;

/**
 *
 * @author idrago
 */
public class Sender extends Thread {
    private Wizard parent;
    
    public Sender(Wizard parent) {
        this.parent = parent;
    }

    public void run() {
        try {
            send();
            parent.panel_wz2.finish_sending();
        } catch (Exception e) {
            parent.error_log.append("Sender ").append(e.getMessage()).append("; ");
            parent.panel_wz2.sending_error();
        } 
    }
    
    public void send() throws Exception {
        TomcatWS_Service nws = new TomcatWS_Service();
        TomcatWS nw = nws.getTomcatWSPort();

        String result = nw.receive(compress(parent.filetable.getMessage()));            
        if (! result.equals("ok")) {
            throw new Exception();
        }
    }
    
    // Compress String.. 
    private static String compress(String mesg) throws Exception {
        if (mesg == null) {
            return "";
        }
        ByteArrayOutputStream out = new ByteArrayOutputStream();
        GZIPOutputStream gzip = new GZIPOutputStream(out);
        gzip.write(mesg.toString().getBytes());
        gzip.close();
        return Base64.encode(out.toByteArray());
    }      
}
